%define expat_version           1.95.5
%define glib2_version           2.2.0
%define qt_version              3.1.0
%define qt_dir			%{_prefix}/lib/qt3

%define lib_major 0
%define lib_api 1
%define lib_name %mklibname dbus- %{lib_api} %{lib_major}
%define lib_glib %mklibname dbus-glib- %{lib_api} %{lib_major}
%define lib_qt %mklibname dbus-qt- %{lib_api} %{lib_major}

Summary: D-BUS message bus
Name: dbus
Version: 0.23.2
Release: 2mdk
URL: http://www.freedesktop.org/Software/dbus/
Source0: //dbus.freedesktop.org/releases/%{name}-%{version}.tar.bz2
Source1: http://freedesktop.org/Software/dbus/%{name}-docs.tar.bz2 
# (fc) 0.20-1mdk fix lock directory location and start/stop order
Patch0: dbus-0.20-lockdir.patch.bz2
# (gb) 0.22-2mdk fix detection of moc path
Patch2: dbus-0.22-qt-moc.patch.bz2
# (fc) 0.23-3mdk allow uid/gid to identify user/group (Fedora)
Patch3: dbus-0.13-uid.patch.bz2
# (fc) 0.23.1-1mdk fix crash when setting group policy (CVS)
Patch5: dbus-0.23.1-groupsegfault.patch.bz2
# (fc) 0.23.2-2mdk fix python binding (CVS)
Patch6: dbus-0.23.2-pythonbinding.patch.bz2
License: AFL/GPL
Group: System/Servers
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildRequires: expat-devel >= %{expat_version}
BuildRequires: glib2-devel >= %{glib2_version}
BuildRequires: qt3-devel    >= %{qt_version}
BuildRequires: gtk+2-devel
BuildRequires: python-devel
BuildRequires: pyrex >= 0.9
BuildRequires: automake1.7
BuildRequires: autoconf2.5 >= 2.54
BuildRequires: kdelibs-devel
PreReq: rpm-helper

%description
D-BUS is a system for sending messages between applications. It is
used both for the systemwide message bus service, and as a
per-user-login-session messaging facility.

%package -n %{lib_name}
Summary: Shared library for using D-BUS
Group: System/Libraries

%description -n %{lib_name}
D-BUS shared library.

%package -n %{lib_name}-devel
Summary: Libraries and headers for D-BUS
Group: Development/C
Requires: %{name} = %{version}-%{release}
Requires: %{lib_name} = %{version}-%{release}
Requires: %{lib_glib} = %{version}-%{release}
Provides: lib%{name}-1-devel = %{version}-%{release}
Provides: lib%{name}-devel = %{version}-%{release}
Provides: %{name}-devel = %{version}-%{release}

%description -n %{lib_name}-devel

Headers and static libraries for D-BUS.

%package -n %{lib_glib}
Summary: GLib-based library for using D-BUS
Group: System/Libraries

%description -n %{lib_glib}
D-BUS add-on library to integrate the standard D-BUS library with
the GLib thread abstraction and main loop.

%package -n %{lib_qt}
Summary: Qt-based library for using D-BUS
Group: System/Libraries

%description -n %{lib_qt}
D-BUS add-on library to integrate the standard D-BUS library with
the Qt thread abstraction and main loop.

%package -n %{lib_qt}-devel
Summary: Qt-based library for using D-BUS
Group: Development/C++
Requires: %lib_name-devel = %version-%release
Requires: %{lib_qt} = %version-%release
Provides: libdbus-qt-1-devel = %version-%release

%description -n %{lib_qt}-devel
D-BUS add-on library to integrate the standard D-BUS library with the
Qt thread abstraction and main loop. This contains the Qt specific
headers and libraries.


%package x11
Summary: X11-requiring add-ons for D-BUS
Group: System/Servers

%description x11
D-BUS contains some tools that require Xlib to be installed, those are
in this separate package so server systems need not install X.

%package python
Summary: Python bindings for D-BUS
Group: Development/Python
Requires: dbus = %{version}-%{release}
 
%description python
The dbus-python package contains a module that permits applications
written in the Python programming language to use the interface
supplied by the D-BUS library.

%prep
%setup -q -a1
%patch0 -p1 -b .lockdir
%patch2 -p1 -b .qt-moc
%patch3 -p1 -b .uid
%patch5 -p1 -b .groupsegfault
%patch6 -p1 -b .pythonbinding

#needed by patch0
aclocal-1.7
automake-1.7 -a -c

#needed by patch2
autoconf

%build

#gw so we can find moc
export PATH=%qt_dir/bin:$PATH
export QTDIR=%qt_dir
%configure2_5x --enable-python --disable-tests --disable-verbose-mode --disable-asserts --disable-mono --disable-mono-docs --with-system-pid-file=%{_var}/run/messagebus.pid --with-system-socket=%{_var}/run/dbus/system_dbus_socket --with-session-socket-dir=/tmp
make

make check

%install
rm -rf %{buildroot}

%makeinstall_std

# move lib to /, because it might be needed by hotplug script, before
# /usr is mounted
mkdir -p $RPM_BUILD_ROOT/%{_lib} 
mv $RPM_BUILD_ROOT%{_libdir}/*dbus-1*.so.* $RPM_BUILD_ROOT/%{_lib} 
ln -sf ../../%{_lib}/libdbus-%{lib_api}.so.%{lib_major} $RPM_BUILD_ROOT%{_libdir}/libdbus-%{lib_api}.so

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/X11/xinit.d
cat << EOF > $RPM_BUILD_ROOT%{_sysconfdir}/X11/xinit.d/dbus
# to be sourced
eval \`/usr/bin/dbus-launch --exit-with-session --auto-syntax\`
EOF
chmod 755 $RPM_BUILD_ROOT%{_sysconfdir}/X11/xinit.d/dbus

#remove unpackaged file
rm -f $RPM_BUILD_ROOT%{_bindir}/dbus-glib-tool $RPM_BUILD_ROOT%{_libdir}/python*/site-packages/*.a $RPM_BUILD_ROOT%{_libdir}/*.la

%clean
rm -rf %{buildroot}

%pre
%_pre_useradd messagebus / /sbin/nologin
%_pre_groupadd daemon messagebus

%post -n %{lib_name} -p /sbin/ldconfig
%postun -n %{lib_name} -p /sbin/ldconfig

%post
%_post_service messagebus

%postun
%_postun_userdel messagebus
%_postun_groupdel daemon messagebus

%preun
%_preun_service messagebus

%post -n %{lib_qt} -p /sbin/ldconfig
%postun -n %{lib_qt} -p /sbin/ldconfig

%post -n %{lib_glib} -p /sbin/ldconfig
%postun -n %{lib_glib} -p /sbin/ldconfig

%triggerpostun -- dbus < 0.21-4mdk
/sbin/chkconfig --del messagebus
/sbin/chkconfig --add messagebus

%files
%defattr(-,root,root)

%doc COPYING ChangeLog NEWS

%dir %{_sysconfdir}/dbus-1
%config(noreplace) %{_sysconfdir}/dbus-1/*.conf
%config(noreplace) %{_sysconfdir}/rc.d/init.d/*
%dir %{_sysconfdir}/dbus-1/system.d
%dir %{_var}/run/dbus
%dir %{_libdir}/dbus-1.0
%{_bindir}/dbus-daemon-1
%{_bindir}/dbus-send
%{_bindir}/dbus-cleanup-sockets
%{_datadir}/man/man*/*
%dir %{_datadir}/dbus-1/
%dir %{_datadir}/dbus-1/services

%files -n %{lib_name}
%defattr(-,root,root)
/%{_lib}/*dbus-1*.so.*

%files -n %{lib_name}-devel
%defattr(-,root,root)
%doc doc/*
%_libdir/libdbus-1.a
%_libdir/libdbus-glib-1.a
%_libdir/libdbus-glib-1.so
%_libdir/libdbus-1.so
%{_libdir}/dbus-1.0/include
%{_libdir}/pkgconfig/dbus-1.pc
%{_libdir}/pkgconfig/dbus-glib-1.pc
%dir %{_includedir}/dbus-1.0
%dir %{_includedir}/dbus-1.0/dbus
%{_includedir}/dbus-1.0/dbus/connection.h
%{_includedir}/dbus-1.0/dbus/dbus-address.h
%{_includedir}/dbus-1.0/dbus/dbus-bus.h
%{_includedir}/dbus-1.0/dbus/dbus-connection.h
%{_includedir}/dbus-1.0/dbus/dbus-errors.h
%{_includedir}/dbus-1.0/dbus/dbus-glib*
%{_includedir}/dbus-1.0/dbus/dbus-macros.h
%{_includedir}/dbus-1.0/dbus/dbus-memory.h
%{_includedir}/dbus-1.0/dbus/dbus-message.h
%{_includedir}/dbus-1.0/dbus/dbus-pending-call.h
%{_includedir}/dbus-1.0/dbus/dbus-protocol.h
%{_includedir}/dbus-1.0/dbus/dbus-server.h
%{_includedir}/dbus-1.0/dbus/dbus-shared.h
%{_includedir}/dbus-1.0/dbus/dbus-threads.h
%{_includedir}/dbus-1.0/dbus/dbus-types.h
%{_includedir}/dbus-1.0/dbus/dbus.h
%{_includedir}/dbus-1.0/dbus/message.h
%{_includedir}/dbus-1.0/dbus/server.h


%files -n %{lib_glib}
%defattr(-,root,root)
%{_libdir}/*glib*.so.*

%files -n %{lib_qt}
%defattr(-,root,root)
%{_libdir}/*qt*.so.*

%files -n %{lib_qt}-devel
%defattr(-,root,root)
%{_libdir}/*qt*.so
%{_libdir}/*qt*.a
%{_includedir}/dbus-1.0/dbus/dbus-qt.h

%files x11
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/X11/xinit.d/*
%{_bindir}/dbus-launch
%{_bindir}/dbus-monitor
%{_bindir}/dbus-viewer

%files python
%defattr(-,root,root)
%{_libdir}/python*/site-packages/dbus*

%changelog
* Tue Mar 01 2005 Frederic Crozat <fcrozat@mandrakesoft.com> 0.23.2-2mdk 
- Patch6 (CVS): fix python binding

* Wed Feb 23 2005 Frederic Crozat <fcrozat@mandrakesoft.com> 0.23.2-1mdk 
- Release 0.23.2
- Remove patch4 (merged upstream)

* Wed Feb 16 2005 Frederic Crozat <fcrozat@mandrakesoft.com> 0.23.1-1mdk 
- Release 0.23.1
- Patch5 (CVS): fix crash when setting group policy

* Wed Feb 16 2005 Frederic Crozat <fcrozat@mandrakesoft.com> 0.23-5mdk 
- Move dbus xinit launcher in dbus-x11 package (Mdk bug #13075)

* Wed Feb  9 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.23-4mdk
- let devel symlinks stay in standard libdir

* Tue Feb 08 2005 Frederic Crozat <fcrozat@mandrakesoft.com> 0.23-3mdk 
- Patch3 (Fedora): allow uid/gid to identify user/group
- Patch4 (Fedora): restrict connection to user session bus to owner or root

* Fri Jan 21 2005 Gtz Waschk <waschk@linux-mandrake.com> 0.23-2mdk
- add missing directory

* Thu Jan 20 2005 Gtz Waschk <waschk@linux-mandrake.com> 0.23-1mdk
- drop patches 1,3
- update source URL
- New release 0.23

* Wed Dec 08 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.22-7mdk 
- automatically start dbus when starting a X11 session

* Sun Dec 05 2004 Michael Scherer <misc@mandrake.org> 0.22-6mdk
- Rebuild for new python

* Mon Nov 15 2004 Christiaan Welvaart <cjw@daneel.dyndns.org> 0.22-5mdk
- add BuildRequires: kdelibs-devel

* Fri Nov 12 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.22-4mdk
- create Qt development package

* Thu Sep 30 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.22-3mdk
- explicitly disable Mono bindings

* Thu Sep 30 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.22-2mdk
- fix detection of moc path
- merge in RH in64 fix for python bindings

* Fri Aug 13 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.22-1mdk
- Release 0.22
- Remove patch1 (merged upstream)
- enable libtoolize 
- Patch1 (Fedora): add console policy

* Mon Aug 09 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.21-4mdk
- Update patch 20 to change start order (should fix bluetooth daemon start)

* Wed Jun 16 2004 Stew Benedict <sbenedict@mandrakesoft.com> 0.21-3mdk
- add docs to -devel, dbus-monitor fixes from cvs (patch1)

* Fri Jun  4 2004 Laurent Montel <lmontel@mandrakesoft.com> 0.21-2mdk
- Rebuild

* Mon Apr 19 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.21-1mdk
- fix qt build
- drop merged patch 1
- fix URL
- new version

* Sat Jan 31 2004 Gtz Waschk <waschk@linux-mandrake.com> 0.20-7mdk
- fix buildrequires

* Thu Jan 29 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.20-6mdk
- Don't package .la, since we are moving some lib to %{_lib}

* Mon Jan 26 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.20-5mdk
- Enable python bindings
- Patch1 (CVS): fix python signals

* Mon Jan 26 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.20-4mdk
- Add missing deps in devel package

* Mon Jan 26 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.20-3mdk
- Move dbus shared library to %{_lib}, needed for hotplug script (Mdk bug 7053)

* Wed Jan 14 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.20-2mdk
- Fix session socket directory location

* Mon Jan 12 2004 Frederic Crozat <fcrozat@mandrakesoft.com> 0.20-1mdk
- Initial Mdk package
- Patch0: fix lock directory location

* Thu Oct 16 2003 Havoc Pennington <hp@redhat.com> 0.13-6
- hmm, dbus doesn't support uids in the config file. fix.

* Thu Oct 16 2003 Havoc Pennington <hp@redhat.com> 0.13-5
- put uid instead of username in the config file, to keep things working with name change

* Thu Oct 16 2003 Havoc Pennington <hp@redhat.com> 0.13-4
- make subpackages require the specific release, not just version, of base package

* Thu Oct 16 2003 Havoc Pennington <hp@redhat.com> 0.13-3
- change system user "messagebus" -> "dbus" to be under 8 chars

* Mon Sep 29 2003 Havoc Pennington <hp@redhat.com> 0.13-2
- see if removing qt subpackage for now will get us through the build system,
  qt bindings not useful yet anyway

* Sun Sep 28 2003 Havoc Pennington <hp@redhat.com> 0.13-1
- 0.13 fixes a little security oops

* Mon Aug  4 2003 Havoc Pennington <hp@redhat.com> 0.11.91-3
- break the tiny dbus-launch that depends on X into separate package
  so a CUPS server doesn't need X installed

* Wed Jun 04 2003 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Sat May 17 2003 Havoc Pennington <hp@redhat.com> 0.11.91-1
- 0.11.91 cvs snap properly merges system.d

* Fri May 16 2003 Havoc Pennington <hp@redhat.com> 0.11.90-1
- build a cvs snap with a few more fixes

* Fri May 16 2003 Havoc Pennington <hp@redhat.com> 0.11-2
- fix a crash that was breaking cups

* Thu May 15 2003 Havoc Pennington <hp@redhat.com> 0.11-1
- 0.11

* Thu May 15 2003 Havoc Pennington <hp@redhat.com> 0.10.90-1
- use rc.d/init.d not init.d, bug #90192
- include the new man pages

* Fri Apr 11 2003 Havoc Pennington <hp@redhat.com> 0.9-1
- 0.9
- export QTDIR explicitly
- re-enable qt, the problem was most likely D-BUS configure

* Tue Apr  1 2003 Havoc Pennington <hp@redhat.com> 0.6.94-1
- update from CVS with a fix to set uid after gid

* Tue Apr  1 2003 Havoc Pennington <hp@redhat.com> 0.6.93-1
- new cvs snap that actually forks to background and changes 
  user it's running as and so forth
- create our system user in pre

* Mon Mar 31 2003 Havoc Pennington <hp@redhat.com> 0.6.92-1
- fix for "make check" test that required a home directory

* Mon Mar 31 2003 Havoc Pennington <hp@redhat.com> 0.6.91-1
- disable qt for now because beehive hates me
- pull a slightly newer cvs snap that creates socket directory
- cat the make check log after make check fails

* Mon Mar 31 2003 Havoc Pennington <hp@redhat.com> 0.6.90-1
- initial build

